#include"table_window.h"

BOOL CALLBACK CtlProc(HWND, UINT, WPARAM, LPARAM);

//񤭸ɽˤ
int candOrder[KEY_NUMBER] = {
    -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
    17,15,13,11,19,18,10,12,14,16,
     7, 5, 3, 1, 9, 8, 0, 2, 4, 6,
    27,25,23,21,29,28,20,22,24,26,
    -1,-1,-1,-1,-1,-1,-1,-1,-1
};

//󥹥ȥ饯
TableWindow::TableWindow(HINSTANCE i) {
    hFont = 0;
    hLFont = 0;
    instance = i;
}

//ǥȥ饯
TableWindow::~TableWindow() {
    delete(rootBlock);
    DeleteObject(hFont);
    delete(tCodeKey);
    delete(miniBuffer);
}

//window procedure
int TableWindow::wndProc(HWND w, UINT msg, WPARAM wp, LPARAM lp) {
    //window handlemessageΰäƤ
    hwnd = w;
    wParam = wp;
    lParam = lp;

    //ƥåhandlerƤ
    switch(msg) {
    case WM_CREATE:
	return handleCreate();

    case WM_PAINT:
	return handlePaint();

    //<si>
#ifdef ORIG
    case WM_LBUTTONDOWN:
	return handleLButtonDown();
#else
    // si ιߤǡѹ
    // ɥκåǡOFF
    case WM_LBUTTONDOWN:
        wParam = ACTIVE_KEY;
        return handleHotKey();
    // ɥαåǡС
    case WM_RBUTTONDOWN:
        return handleLButtonDown();
#endif
    //</si>

    case WM_DESTROY:
	return handleDestroy();

    case KANCHOKU_ICONCLK:
	if(lParam == WM_LBUTTONDOWN) {
	    wParam = ACTIVE_KEY;
	    return handleHotKey();
	}
	return 0;
    case WM_HOTKEY:
	return handleHotKey();
    }
    return DefWindowProc(hwnd, msg, wParam, lParam);
}

//ʸν
void TableWindow::outputString(char *s) {
    //ϥեĥɥ
    HWND targetWin = GetForegroundWindow();
    DWORD targetThread = GetWindowThreadProcessId(targetWin, NULL);
    DWORD selfThread = GetCurrentThreadId();
    AttachThreadInput(selfThread, targetThread, TRUE);
    HWND activeWin = GetFocus();

    //ʸ
    char *pt = s;

    while(*pt != 0) {
	//<si>
#ifdef ORIG
	if(*pt & 0x80) {
	    //ȥåץӥåȤΩäƤ
	    //ޤȤ2byte
#else
	if(IS_SJIS1(*pt)){ // Ƭ 1 ХȤơ2 ХʸȽ
	    // 2Хʸʤ顢ޤȤ 2 Х
#endif
	//</si>
	    if(messageKind == WM_IME_CHAR) {
		int tmp =
		    (*(unsigned char *)pt << 8) +
			*((unsigned char *)pt + 1);
		PostMessage(activeWin, WM_IME_CHAR, tmp, 1);

	    } else {
		PostMessage(activeWin, WM_CHAR, (unsigned char)*pt, 1);
		PostMessage(activeWin, WM_CHAR, (unsigned char)*(pt + 1), 1);
	    }
	    pt++;
	} else {
	    //Ǥʤ
	    //1byte
	    //<si>
#ifdef ORIG
	    PostMessage(activeWin, messageKind, *pt, 1);
#else
	    // ȾѤʸ WM_IME_CHAR ǡ
	    // Ⱦ ASCII ʸ WM_CHAR 
	    if(IS_HANKANA(*pt)){
		PostMessage(activeWin, WM_IME_CHAR, *pt, 1);
	    }else{
		PostMessage(activeWin, WM_CHAR, *pt, 1);
	    }
#endif
	    //</si>
	}
	pt++;
    }

//   ȤꤢimmȤϼԤ
//   ⤷IMEϡդ褭뤫⡣
//    HIMC hImc = ImmGetContext(activeWin);
//    HIMC hImc = (HIMC)GetWindowLong(activeWin, 0); //0 = IMMGWL_IMC
//    HIMC hImc = ImmCreateContext();
//    if(hImc == NULL) {
//	exit(1);
//    }

//    ImmSetCompositionString(0, SCS_SETSTR,pt,strlen(pt), pt, strlen(pt));
//    HIMC oldImc = ImmAssociateContext(activeWin,hImc);
//    if(oldImc == NULL) {
//	exit(1);
//    }

//    ImmSetCompositionString(hImc, SCS_SETSTR,pt,strlen(pt), pt, strlen(pt));
//    if(oldImc == NULL) {
//	exit(1);
//    }
//    PostMessage(activeWin, WM_IME_COMPOSITION, 0, GCS_RESULTSTR);

    //åɤڤΥ
    AttachThreadInput(selfThread, targetThread, FALSE);
}

//<si>
#ifndef ORIG
// 
void TableWindow::outputKey(int vk, int n){
    // ϥեǤĥɥ
    HWND targetWin = GetForegroundWindow();
    DWORD targetThread = GetWindowThreadProcessId(targetWin, NULL);
    DWORD selfThread = GetCurrentThreadId();
    AttachThreadInput(selfThread, targetThread, TRUE);
    HWND activeWin = GetFocus();

    for(int i = 0; i < n; i++){
	PostMessage(activeWin, WM_KEYDOWN, vk, 0);
    }

    // åɤڤΥ
    AttachThreadInput(selfThread, targetThread, FALSE);
}

void TableWindow::outputKey(int vk){
    outputKey(vk, 1);
}
#endif
//</si>

//<si>
#ifndef ORIG
// ַ򤼽ѴϢ
// ľϤʸ򵭲Ƥ
void TableWindow::outputToRingBuffer(char *s){
    int len = strlen(ringBuffer);
    if(IS_SJIS1(*s)){
	// ʸǻϤޤ
	// Ƭ 1 ʸ򵭲 (ȴ)
	if(len + 2 < RINGBUFFERSIZE){
	    strncat(ringBuffer, s, 2);
	    ringBuffer[len + 2] = 0;
	}else{
	    memmove(ringBuffer, ringBuffer + 2, len - 1);
	    strncat(ringBuffer, s, 2);
	    ringBuffer[len + 2] = 0;
	}
    }else{
	// ȾʸǻϤޤ
	// ⤷ʤ (ȴ)
    }
}

void TableWindow::clearRingBuffer(){
    ringBuffer[0] = 0;
}

/**
 * ringBufferκǸʸringBufferä
 */
void TableWindow::backspaceRingBuffer(){
    // XXX: ȾʸringBufferäƤʤȤ (ȴ)
    int i = strlen(ringBuffer) - 2;
    if(i < 0)
	return;
    ringBuffer[i] = '\0';
}
#endif
//</si>

//mini bufferؤʸ
void TableWindow::outputStringToMiniBuffer(char *s) {
    //ʸĹå
    int srcLen = strlen((char *)s);
    if((srcLen + miniBufferSize) >= (MINI_BUFFER_SIZE - 1)) {
	return;
    }

    //ʸʸå
    int count = countChar(s);

    strcpy((char *)(miniBuffer + miniBufferSize), (char *)s);
    miniBufferSize += srcLen;
    miniBufferCount += count;
}

//<si>
int TableWindow::countChar(char *s) {
    int ret = 0;
    while(*s != 0) {
#ifdef ORIG
	if(*s & 0x80) {
#else
	if(IS_SJIS1(*s)){ // Ƭ 1 ХȤȽ
#endif
	    ret++;
	    s+=2;
	} else {
	    ret++;
	    s++;
	}
    }
    return ret;
}
//</si>

void TableWindow::clearMiniBuffer() {
    miniBuffer[0] = 0;
    miniBufferSize = 0;
    miniBufferCount = 0;
}

//ư
void TableWindow::activate() {
    //ɽ
    if(hideMode == 1) {
	ShowWindow(hwnd, SW_SHOWNA);
    }


    //HotKeyγ
    for(int i = 0; i < KEY_NUMBER; i++) {
	RegisterHotKey(hwnd, i, 0, tCodeKey[i]);
    }

    //<si>
#ifndef ORIG
    // ESCAPE  RETURN  BS ⲣꤷ㤦
    RegisterHotKey(hwnd, ESC_KEY, 0, VK_ESCAPE);
    RegisterHotKey(hwnd, BS_KEY, 0, VK_BACK);
    RegisterHotKey(hwnd, CH_KEY, MOD_CONTROL, 'H');
    RegisterHotKey(hwnd, RET_KEY, 0, VK_RETURN);
    RegisterHotKey(hwnd, CM_KEY, MOD_CONTROL, 'M');
    RegisterHotKey(hwnd, CJ_KEY, MOD_CONTROL, 'J');
    RegisterHotKey(hwnd, TAB_KEY, 0, VK_TAB);
#endif
    //</si>

    //̾⡼ɤˤ
    inputMode = INPUT_NORMAL;
    clearMiniBuffer();
    //<si>
#ifndef ORIG
    clearRingBuffer(); // ַ򤼽ѴѤΥХåե򥯥ꥢ
    clearHelpBuffer(); // إоʸΥХåե򥯥ꥢ
    helpMode = 0; // إɽ
#endif
    //</si>
}

//Ե
void TableWindow::inactivate() {
    //
    if(hideMode == 1) {
	ShowWindow(hwnd, SW_HIDE);
    }

    //HotKeyβ
    for(int i = 0; i < KEY_NUMBER; i++) {
	UnregisterHotKey(hwnd, i);
    }
    UnregisterHotKey(hwnd, ESC_KEY);
    UnregisterHotKey(hwnd, BS_KEY);
    UnregisterHotKey(hwnd, CH_KEY);
    //<si>
#ifndef ORIG
    UnregisterHotKey(hwnd, RET_KEY);
    UnregisterHotKey(hwnd, CM_KEY);
    UnregisterHotKey(hwnd, CJ_KEY);
    UnregisterHotKey(hwnd, TAB_KEY);
#endif
    //</si>

    //̾⡼ɤˤ
    inputMode = INPUT_NORMAL;
}

//EscBsCtrl-Hʤ
void TableWindow::setSpecialHotKey() {
    if((rootBlock == currentBlock) &&
       (inputMode == INPUT_NORMAL)) {
	UnregisterHotKey(hwnd, ESC_KEY);
	UnregisterHotKey(hwnd, BS_KEY);
	UnregisterHotKey(hwnd, CH_KEY);
	//<si>
#ifndef ORIG
	UnregisterHotKey(hwnd, RET_KEY);
	UnregisterHotKey(hwnd, CM_KEY);
	UnregisterHotKey(hwnd, CJ_KEY);
	UnregisterHotKey(hwnd, TAB_KEY);
#endif
	//</si>
    } else {
	RegisterHotKey(hwnd, ESC_KEY, 0, VK_ESCAPE);
	RegisterHotKey(hwnd, BS_KEY, 0, VK_BACK);
	RegisterHotKey(hwnd, CH_KEY, MOD_CONTROL, 'H');
	//<si>
#ifndef ORIG
	RegisterHotKey(hwnd, RET_KEY, 0, VK_RETURN);
	RegisterHotKey(hwnd, CM_KEY, MOD_CONTROL, 'M');
	RegisterHotKey(hwnd, CJ_KEY, MOD_CONTROL, 'J');
	RegisterHotKey(hwnd, TAB_KEY, 0, VK_TAB);
#endif
	//</si>
    }
}

//ȥСʸ򥻥å
void TableWindow::setTitleText() {
    //<si>
#ifdef ORIG
    if(isActive == 0) {
	SetWindowText(hwnd, "ľWin[Off]");
    } else {
	if(inputMode == INPUT_MAZEGAKI) {
	    SetWindowText(hwnd, "ľWin[On(Ѵ)]");
# ifdef BUSHU
	} else if(inputMode == INPUT_BUSHU) {
	    SetWindowText(hwnd, "ľWin[On()]");
# endif
	} else if(tableMode == MODE_A) {
	    SetWindowText(hwnd, "ľWin[On(A)]");
	} else {
	    SetWindowText(hwnd, "ľWin[On(B)]");
	}
    }
#else
    // si ߤѹ㤦
    if(isActive == 0) {
	SetWindowText(hwnd, "ľWin [OFF]");
    } else {
	if(inputMode == INPUT_MAZEGAKI) {
	    SetWindowText(hwnd, "ľWin [Ѵ]");
# ifdef BUSHU
	} else if(inputMode == INPUT_BUSHU) {
	    SetWindowText(hwnd, "ľWin []");
# endif
	} else if(tableMode == MODE_A) {
	    SetWindowText(hwnd, "ľWin [ON/A]");
	} else {
	    SetWindowText(hwnd, "ľWin [ON/B]");
	}
    }
#endif
    //</si>
}

//WM_CREATE
int TableWindow::handleCreate() {
    //ȥ쥤Ͽ
    NOTIFYICONDATA nid;
    nid.cbSize = sizeof(NOTIFYICONDATA);
    nid.hWnd = hwnd;
    nid.uID = 0;
    nid.uFlags = 7; //NIF_ICON | NIF_MESSAGE | NIF_TIP
    nid.uCallbackMessage = KANCHOKU_ICONCLK;
    nid.hIcon = LoadIcon(instance, "kanmini");
    strcpy(nid.szTip, "ľWin");
    Shell_NotifyIcon(0 /* NIM_ADD */, &nid);

    //ե򳫤
    ifstream *is = new ifstream();
    is->open("kanchoku.ini", is->nocreate);
    if(is->fail()) {
	//
	error("kanchoku.iniե뤬ޤ");
    }

    //ɤ߹
    int hotKey = 0;          //On/Offڤؤβۥ
    char tableFileName[255]; //ơ֥ե̾
    tableFileName[0] = 0;
    char keyFileName[255];   //ܡɥե̾
    keyFileName[0] = 0;
    char mazegakiFileName[255];   //񤭼ե̾
    mazegakiFileName[0] = 0;
#ifdef BUSHU
    char bushuFileName[255];   //Ѵե̾
    bushuFileName[0] = 0;
#endif
    char message[255];   //Фå
    message[0] = 0;
    char hide[255];   //ɤ
    hide[0] = 0;
    char buffer[255];
    int xloc = -1;
    int yloc = -1;

    //<si>
#ifndef ORIG
    char forceBS[255]; // BS εư
    forceBS[0] = 0;
    char showHelp[255]; // 򤼽ѴϤʸΥإפɽ뤫
    showHelp[0] = 0;
#endif
    //</si>

    while(!(is->eof())) {
	is->getline(buffer, 255);
	switch(buffer[0]) {
	case '#': //ȹ
	    break;
	case 'H': //ڤؤ
	    sscanf(buffer, "HOTKEY=%x\n",&hotKey);
	    break;
	case 'T': //ơ֥ե̾
	    sscanf(buffer, "TABLEFILE=%s\n",tableFileName);
	    break;
	case 'K': //ܡɥե̾
	    sscanf(buffer, "KEYBOARD=%s\n",keyFileName);
	    break;
	case 'M': //񤭥ե̾
	    sscanf(buffer, "MAZEGAKI=%s\n",mazegakiFileName);
	    break;
#ifdef BUSHU
	case 'B': //Ѵե̾
	    sscanf(buffer, "BUSHU=%s\n",bushuFileName);
	    break;
#endif
	case 'U': //Ф륤٥
	    sscanf(buffer, "USEWMCHAR=%s\n",message);
	    break;
	case 'X': //и֤Xɸ
	    sscanf(buffer, "XLOC=%d\n",&xloc);
	    break;
	case 'Y': //и֤Yɸ
	    sscanf(buffer, "YLOC=%d\n",&yloc);
	    break;
	case 'O': //
	    sscanf(buffer, "OFFHIDE=%s\n",hide);
	    break;
	//<si>
#ifndef ORIG
	case 'F': // BS εư
	    sscanf(buffer, "FORCEBS=%s\n", forceBS);
	    break;
	case 'S': // إɽ
	    sscanf(buffer, "SHOWHELP=%s\n", showHelp);
	    break;
#endif
	//</si>
	default:
	    break;
	}
    }
    is->close();

    //ɤ߹᤿å
    if(hotKey == 0) {
	error("HOTKEY=(16ʥ)̵꤬ޤϰ۾Ǥ");
    }
    if(tableFileName[0] == 0) {
	error("TABLEFILE=(ե̾)̵꤬ޤϰ۾Ǥ");
    }
    if(keyFileName[0] == 0) {
	error("KEYBOARD=(ե̾)̵꤬ޤϰ۾Ǥ");
    }
    if(mazegakiFileName[0] == 0) {
	mazeAble = MAZE_NOT_USE;
    } else {
	mazeAble = MAZE_USE;
    }
#ifdef BUSHU
    if(bushuFileName[0] == 0) {
	bushuAble = BUSHU_NOT_USE;
    } else {
	bushuAble = BUSHU_USE;
    }
#endif

    messageKind = WM_IME_CHAR;
    if(message[0] != 0) {
	if(strcmp(message,"ON") == 0) {
	    messageKind = WM_CHAR;
	}
    }

    hideMode = 0;
    if(hide[0] != 0) {
	if(strcmp(hide,"ON") == 0) {
	    hideMode = 1;
	}
    }

    //<si>
#ifndef ORIG
    // BS εư
    forceBSMode = 0;
    if(forceBS[0] != 0){
	if(strcmp(forceBS, "ON") == 0){
	    forceBSMode = 1;
	}
    }
    // إɽ
    showHelpMode = 0;
    if(showHelp[0] != 0){
	if(strcmp(showHelp, "ON") == 0){
	    showHelpMode = 1;
	}
    }
#endif
    //</si>

    //ܡɥեɤ߹
    tCodeKey = new int[KEY_NUMBER]; //ΰγ
    FILE *fp = fopen(keyFileName,"r");
    if(fp == 0) {
	//
	error("ܡɥե뤬ޤ");
    }
    for(int i = 0; i < KEY_NUMBER; i++) {
	int vCode;
	fscanf(fp, "%x,",&vCode);
	tCodeKey[i] = vCode;
    }
    fclose(fp);

    //ơ֥եɤ߹
    //ơ֥ե򳫤
    is->open(tableFileName, is->nocreate);
    if(is->fail()) {
	error("ơ֥ե뤬ޤ");
    }

    //ѡ
    Parser *parser = new Parser(is, hwnd);
    modeABlock = parser->parse();
    modeBBlock = parser->parse();
    is->close();
    delete(parser);

    //񤭼ɤ߹(ѤΤ)
    if(mazeAble == MAZE_USE) {
	is->open(mazegakiFileName, is->nocreate);
	if(is->fail()) {
	    //<si>
#ifdef ORIG
	    error("񤭼񤬳ޤ");
#else
	    error("򤼽񤭼񤬳ޤ");
#endif
	    //</si>
	}
	mgTable = new MgTable(hwnd);
	mgTable->readFile(is);
    }

#ifdef BUSHU
    //Ѵɤ߹(ѤΤ)
    if(bushuAble == BUSHU_USE) {
	switch (read_bushu_dic(bushuFileName)) {
	case 0:		// SUCCESS
	    break;
	case BE_NOMEM:
	    error("Ѵɤ߹˥ݤ˼Ԥޤ");
	    break;
	case BE_BIG:
	    error("ѴΥ礭ޤ");
	    break;
	case BE_FOPEN:
	default:
	    error("Ѵ񤬳ޤ");
	    break;
	}
    }
#endif

    //ߥ˥Хåեΰ
    miniBuffer = new char[MINI_BUFFER_SIZE];
    clearMiniBuffer();

    //<si>
#ifndef ORIG
    // ַ򤼽ѴѤΥХåեν
    clearRingBuffer();
    // إפΤν
    clearStrokeTable();
    makeStrokeTable();
    clearHelpBuffer();
    helpMode = 0;
#endif
    //</si>

    //⡼ɤ
    rootBlock = modeABlock;
    currentBlock = rootBlock;
    tableMode = MODE_A;
    inputMode = INPUT_NORMAL;

    //Ե֤
    isActive = 0;

    //Ȥ礭
    RECT winRect;
    GetWindowRect(hwnd, &winRect);

    //Ȥ礭
    RECT clientRect;
    GetClientRect(hwnd, &clientRect);

    //κɸ
    int sX = winRect.left;
    int sY = winRect.top;

    //ȤȤκ
    int dX = (winRect.right - winRect.left)
	- (clientRect.right - clientRect.left);
    int dY = (winRect.bottom - winRect.top)
	- (clientRect.bottom - clientRect.top);

    //礭򹹿
    if(xloc != -1) {
	sX = xloc;
    }
    if(yloc != -1) {
	sY = yloc;
    }
    MoveWindow(hwnd, sX, sY,
	       BLOCK_SIZE * 11 + dX, BLOCK_SIZE * 5 + dY, TRUE);

    //եȤ
    LOGFONT lf;
    lf.lfHeight = CHAR_SIZE;
    lf.lfWidth = 0;
    lf.lfEscapement = 0;
    lf.lfOrientation = 0;
    lf.lfWeight = 0;
    lf.lfItalic = 0;
    lf.lfUnderline = 0;
    lf.lfStrikeOut = 0;
    lf.lfCharSet = SHIFTJIS_CHARSET;
    lf.lfOutPrecision = 0;
    lf.lfClipPrecision = 0;
    lf.lfQuality = 0;
    lf.lfPitchAndFamily = 0;
    strcpy(lf.lfFaceName, "ͣ å");
    hFont = CreateFontIndirect(&lf);

    //礭եȤ
    lf.lfHeight = LARGE_CHAR_SIZE;
    hLFont = CreateFontIndirect(&lf);

    //ӥåȥޥåפɤ߹
    bmOff = LoadBitmap(instance, "bmOff");
    bmOn1 = LoadBitmap(instance, "bmOn1");
    bmOn2 = LoadBitmap(instance, "bmOn2");

    //ưΤHotKeyϿ
    RegisterHotKey(hwnd, ACTIVE_KEY, MOD_CONTROL, hotKey);

    //Ե֤
    inactivate();

    return 0;
}

//WM_PAINT
int TableWindow::handlePaint() {
    PAINTSTRUCT ps;
    HDC hdc;

    //賫
    hdc = BeginPaint(hwnd, &ps);
    //ȥʸ
    setTitleText();

    //<si>
#ifndef ORIG
    if(showHelpMode && helpMode){
	// إפɽϡ˽Ф
	drawFrame(hdc);
	drawHelp(hdc);

	//轪λ
	EndPaint(hwnd, &ps);
	return 0;
    }
#endif
    //</si>

    if(inputMode == INPUT_NORMAL) {
	//ӥåȥޥåפɽ
	HDC hdcMem = CreateCompatibleDC(hdc);
	HGDIOBJ tmp;
	if(isActive == 0) {
	    tmp = SelectObject(hdcMem, bmOff);
	} else {
	    if(tableMode == MODE_A) {
		tmp = SelectObject(hdcMem, bmOn1);
	    } else {
		tmp = SelectObject(hdcMem, bmOn2);
	    }
	}
	BitBlt(hdc, BLOCK_SIZE * 5, 0, BLOCK_SIZE, BLOCK_SIZE * 4,
	       hdcMem, 0, 0, SRCCOPY);
	SelectObject(hdcMem, tmp);
	DeleteDC(hdcMem);
    } else {
	int limit;

	//mini bufferɽ
	//طʤĤ֤
	RECT r;
	r.top = 0;
	r.left = BLOCK_SIZE * 5;
	r.right = BLOCK_SIZE * 6;
	if(inputMode == INPUT_CAND_F) {
	    //10İʲλϲޤɤ
	    r.bottom = BLOCK_SIZE * 5;
	    limit = 5;
	} else {
	    r.bottom = BLOCK_SIZE * 4;
	    limit = 4;
	}

	//
	if(inputMode == INPUT_MAZEGAKI) {
	    FillRect(hdc, &r, (HBRUSH)GetStockObject(WHITE_BRUSH));
	    SetTextColor(hdc, BLACK);
	    SetBkColor(hdc, WHITE);
	} else {
	    FillRect(hdc, &r, (HBRUSH)GetStockObject(BLACK_BRUSH));
	    SetTextColor(hdc, WHITE);
	    SetBkColor(hdc, BLACK);
	}

	//եȤ
	HGDIOBJ tmp = SelectObject(hdc, hLFont);

	//ʸɽ
	//ݥ󥿤Υå
	char *pt = miniBuffer;

	//4ʸۤϲʸɤФ
	if(miniBufferCount > limit) {
	    for(int i = 0; i < (miniBufferCount - limit); i++) {
		if(*pt & 0x80) {
		    pt += 2;
		} else {
		    pt++;
		}
	    }
	}

	//ɽ
	int px = BLOCK_SIZE * 5;
	for(int y = 0; y < limit; y++) {
	    if(*pt == 0) {
		break;
	    }

	    int py = BLOCK_SIZE * y;
	    if(*pt & 0x80) {
		//2byteʸ
		TextOut(hdc, px + 1, py + 1, (char *)pt, 2);
		pt += 2;
	    } else {
		//1byteʸ
		TextOut(hdc, px + 1 + (LARGE_CHAR_SIZE / 4),
			py + 1, (char *)pt, 1);
		pt++;
	    }
	}
    }
    SelectObject(hdc, hLFont);

    //ʸΤϤޥ
    if(inputMode == INPUT_CAND_F) {
	//Ľ10
	drawLongFrame(hdc);
    } else {
	//̾
	drawFrame(hdc);
    }

    //եȤ
    HGDIOBJ tmp = SelectObject(hdc, hFont);

    //ʸο
    SetTextColor(hdc, BLACK);
    SetBkColor(hdc, LGRAY);

    //ʸɽ
    int count = 0;
    for(int y = 0; y < 5; y++) {
	for(int x = 0; x < 10; x++) {
	    int px = BLOCK_SIZE * x - 1;
	    int py = BLOCK_SIZE * y;
	    if(y == 4) {
		px += BLOCK_SIZE / 2;
	    } else if(x >= 5) {
		px += BLOCK_SIZE;
	    }
	    //ʸɽ
	    if((inputMode == INPUT_NORMAL) ||
#ifndef BUSHU
	       (inputMode == INPUT_MAZEGAKI)) {
#else
	       (inputMode == INPUT_MAZEGAKI) || (inputMode == INPUT_BUSHU)) {
#endif
		//̾狼minibufferϤξ
		if(currentBlock->block[count] != 0) {
		    TextOut(hdc, px + 3, py + 3,
			    currentBlock->block[count]->getFace(), 2);

		}
	    } else if(inputMode == INPUT_CAND_M) {
		//ɽ⡼ɤξ
		if(candOrder[count] != -1) {
		    //<si>
#ifdef ORIG
		    int oc = offset + candOrder[count];
#else
		    // ʤ󤫡ѥ餬ʸäΤ
		    unsigned int oc = offset + candOrder[count];
#endif
		    //</si>
		    if(oc < currentCand->size()) {
			TextOut(hdc, px + 3, py + 3,
				(*currentCand)[oc], 2);
		    }
		}
	    } else {
		//ɽ⡼(<=10)ξ
		if(candOrder[count] != -1) {
		    //<si>
#ifdef ORIG
		    int oc = offset + candOrder[count];
#else
		    // ʤ󤫡ѥ餬ʸäΤ
		    unsigned int oc = offset + candOrder[count];
#endif
		    //</si>
		    if(oc < currentCand->size()) {
			char *pt = (*currentCand)[oc];

			//ɽ
			for(int y = 0; y < 6; y++) {
			    if(*pt == 0) {
				break;
			    }

			    int py = (CHAR_SIZE + 1) * y + 5;
			    if(*pt & 0x80) {
				//2byteʸ
				TextOut(hdc, px + 4, py, pt, 2);
				pt += 2;
			    } else {
				//1byteʸ
				TextOut(hdc, px + 4 + (CHAR_SIZE / 4),
					py, pt, 1);
				pt++;
			    }
			}
		    }
		}
	    }
	    count++;
	    if(count == KEY_NUMBER) {
		break;
	    }
	}
    }
    SelectObject(hdc, tmp);

    //轪λ
    EndPaint(hwnd, &ps);
    return 0;
}

//WM_LBUTTONDOWN
int TableWindow::handleLButtonDown() {
//<si>
#ifdef ORIG
    char *buffer = new char[255];
    sprintf(buffer,
	    "ľף %s \n"
	    "\n"
	    "ХݡȤϲɥ쥹\n"
	    "tokuoka@taurus.bekkoame.ne.jp",
	    VERSION);
#else
    char *buffer = new char[1024];
    sprintf(buffer,
	    "         ľWin %s\n"
	    "\n"
	    "      Original by \n"
	    "      Patched by 椻Ҥ\n"
	    "\n"
	    "ХݡȤϡǤ\n"
	    "T-Code ML ޤǤ󤻤",
	    VERSION);
#endif
//</si>
    MessageBoxEx(hwnd, buffer, "С", MB_OK , LANG_JAPANESE);
    delete(buffer);
//    DialogBox(instance, "ControlBox", hwnd, CtlProc);
    return 0;
}

//WM_DESTROY
int TableWindow::handleDestroy() {
    //Ե֤ˤ
    inactivate();

    //<si>
#ifndef ORIG
    // إѤΥơ֥θ
    deleteStrokeTable();
#endif
    //</si>

    //HotKey
    UnregisterHotKey(hwnd, ACTIVE_KEY);

    //BitMap
    DeleteObject(bmOff);
    DeleteObject(bmOn1);
    DeleteObject(bmOn2);

    //ȥ쥤
    NOTIFYICONDATA nid;
    nid.cbSize = sizeof(NOTIFYICONDATA);
    nid.hWnd = hwnd;
    nid.uID = 0;
    Shell_NotifyIcon(2 /* NIM_DELETE */, &nid);

    //λ
    PostQuitMessage(0);
    return 0;
}

//WM_HOTKEY
int TableWindow::handleHotKey() {
    //<si>
#ifndef ORIG
    // Ϥä顢إɽ
    helpMode = 0;
#endif
    //</si>
    switch(wParam) {
    case ACTIVE_KEY:
	if(isActive == 0) {
	    //ư
	    activate();
	    isActive = 1;
	} else {
	    //Ե
	    inactivate();
	    isActive = 0;
	}
	currentBlock = rootBlock;
	break;
    case BS_KEY:
    case CH_KEY:
	if(inputMode == INPUT_NORMAL) {
	    //<si>
#ifndef ORIG
	    // BS ν
	    if(forceBSMode == 0){
		// normalBS
		if(currentBlock == rootBlock){
		    if(wParam == BS_KEY){outputKey(VK_BACK);}
		    if(wParam == CH_KEY){outputKey('H');} // ʤǤΤ?
		    backspaceRingBuffer();
		}
	    }else{
		// forceBS
		if(wParam == BS_KEY){outputKey(VK_BACK);}
		if(wParam == CH_KEY){outputKey('H');} // ʤǤΤ?
		backspaceRingBuffer();
	    }
#endif
	    //</si>
	    currentBlock = rootBlock;
#ifndef BUSHU
	} else if (inputMode == INPUT_MAZEGAKI) {
#else
	} else if (inputMode == INPUT_MAZEGAKI || inputMode == INPUT_BUSHU) {
#endif
	    if(currentBlock != rootBlock) {
		currentBlock = rootBlock;
	    } else if(miniBufferCount != 0) {
		miniBufferCount--;
		miniBufferSize--;
		miniBuffer[miniBufferSize] = 0;
		if(miniBuffer[miniBufferSize - 1] & 0x80) {
		    miniBufferSize--;
		    miniBuffer[miniBufferSize] = 0;
		}
	    } else {
		currentBlock = rootBlock;
		inputMode = INPUT_NORMAL;
		clearMiniBuffer();
	    }
	} else {
	    currentBlock = rootBlock;
	    inputMode = INPUT_MAZEGAKI;
	}
	break;
    case ESC_KEY:
	if(inputMode == INPUT_NORMAL) {
	    //<si>
#ifndef ORIG
	    // ǸȤϤ줿Τʤ顢ESC 򲡤Ȥˤ
	    if(currentBlock == rootBlock){
		outputKey(VK_ESCAPE);
	    }
#endif
	    //</si>
	    currentBlock = rootBlock;
#ifndef BUSHU
	} else if (inputMode == INPUT_MAZEGAKI) {
#else
	} else if (inputMode == INPUT_MAZEGAKI || inputMode == INPUT_BUSHU) {
#endif
	    currentBlock = rootBlock;
	    inputMode = INPUT_NORMAL;
	    clearMiniBuffer();
	} else {
	    currentBlock = rootBlock;
	    inputMode = INPUT_MAZEGAKI;
	}
	break;
	//<si>
#ifndef ORIG
	// RETURN ν
	case RET_KEY:
	case CM_KEY:
	case CJ_KEY:
	    if(inputMode == INPUT_NORMAL){
		currentBlock = rootBlock;
		// RET 򲡤Ȥˤ
		switch(wParam){
		case RET_KEY: outputKey(VK_RETURN); break;
		case CM_KEY:  outputKey('M'); break; // ʤǤΤ?
		case CJ_KEY:  outputKey('J'); break; // (Ʊ)
		default: break;
		}
#ifndef BUSHU
	    }else if(inputMode == INPUT_MAZEGAKI){
#else
	    }else if(inputMode == INPUT_MAZEGAKI || inputMode == INPUT_BUSHU){
#endif
		currentBlock = rootBlock;
		inputMode = INPUT_NORMAL;
		clearMiniBuffer();
	    }else{
		currentBlock = rootBlock;
		inputMode = INPUT_NORMAL;
		clearMiniBuffer();
	    }
	    break;
    // TAB ν
    case TAB_KEY:
	if(inputMode == INPUT_NORMAL){
	    if(currentBlock == rootBlock){
		// ǸȤϤ줿顢TAB 򲡤Ȥˤ
		outputKey(VK_TAB);
	    }else{
		// ǸȤϤ줿顢ǸϤȤˤ
		currentBlock = rootBlock;
		outputKey(tCodeKey[lastTCodeKeyNum]);
	    }
	}
	break;
#endif
	//</si>
    default:
	if((inputMode == INPUT_CAND_F) ||
	   (inputMode == INPUT_CAND_M)) {
	    //񤭤θɽξ
	    if(wParam == 40) {
		//θ䷲
		offset += 30;
		if(offset >= currentCand->size()) {
		    offset = 0;
		}
	    } else {
		if(candOrder[wParam] != -1) {
		    //<si>
#ifdef ORIG
		    int oc = offset + candOrder[wParam];
#else
		    // ʤ󤫡ѥ餬ʸäΤ
		    unsigned int oc = offset + candOrder[wParam];
#endif
		    //</si>
		    if(oc < currentCand->size()) {
			//䤬¸ߤн
			outputString((*currentCand)[oc]);
			//<si>
#ifndef ORIG
			// إоʸϿ
			outputToHelpBuffer((*currentCand)[oc]);
#endif
			//</si>
			inputMode = INPUT_NORMAL;
			currentBlock = rootBlock;
			clearMiniBuffer();
		    }
		}
	    }
	    break;
	}

	//<si>
	// ľǸ򵭲Ƥ (Ǹ TAB ǻȤ褦)
	lastTCodeKeyNum = wParam;
	//</si>

	Block *nextBlock = (currentBlock->block)[wParam];
	if(nextBlock == 0) {
	    //֥󥯤ξ
#ifndef ORIG
	    //<si>
	    // 򤼽ѴǡSPC ä顢Ѵμ¹
	    if(inputMode == INPUT_MAZEGAKI && wParam == 40){
		mazeSub();
	    }
	    //</si>
#endif
	    //root
	    currentBlock = rootBlock;
	    break;
	}
	switch(nextBlock->kind()) {
	case STRING_BLOCK:
	    //ʸ֥åξ
	    //Ϥ
	    if(inputMode == INPUT_NORMAL) {
		//<si>
#ifdef ORIG
		outputString(((StringBlock *)nextBlock)->str);
#else
		// ñȤΥڡʤ顢SPC 򲡤Ȥˤ
		// (Ѷʤ餳θ¤ǤϤʤ)
		char *str = ((StringBlock *)nextBlock)->str;
		if(!strcmp(str, " ")){
		    outputKey(VK_SPACE);
		}else{
		    outputString(str);
		    outputToRingBuffer(str);
		}
#endif
		//</si>
#ifdef BUSHU
	    } else if(inputMode == INPUT_BUSHU) {
		char *str = ((StringBlock *)nextBlock)->str;
		if(miniBufferCount < 1) {
		    outputStringToMiniBuffer(str);
		} else {
		    char *p = miniBuffer;
		    int ch = tcode_lookup_outset(get_moji(&p), get_moji(&str));
		    if(ch != 0) {
			char tmp[] = { (ch>>8) & 0xff, ch & 0xff, '\0' };
			outputString(tmp);
#ifndef ORIG
			outputToHelpBuffer(tmp);
			outputToRingBuffer(tmp);
#endif
			clearMiniBuffer();
			inputMode = INPUT_NORMAL;
		    }
		}
#endif	/* BUSHU */
	    } else {
		//<si>
#ifdef ORIG
		outputStringToMiniBuffer(((StringBlock *)nextBlock)->str);
#else
		// ñȤΥڡʤ顢Ѵ¹
		// (ȾѶϸ򤼽Ѵɤߤ˴ޤʤä?)
		char *str = ((StringBlock *)nextBlock)->str;
		if(!strcmp(str, " ") || !strcmp(str, "")){ // Ѷ
		    mazeSub();
		}else{
		    outputStringToMiniBuffer(((StringBlock *)nextBlock)->str);
		}
#endif
		//</si>
	    }
	    currentBlock = rootBlock;
	    break;
	case CONTROL_BLOCK:
	    //ȥξ
	    //β̤ɽ
	    currentBlock = (ControlBlock *)nextBlock;
	    break;
	case SPECIAL_BLOCK:
	    //üξ
	    switch(((SpecialBlock *)nextBlock)->function) {
	    case F_SWITCH_MODE: //⡼
		if(tableMode == MODE_A) {
		    tableMode = MODE_B;
		    rootBlock = modeBBlock;
		} else {
		    tableMode = MODE_A;
		    rootBlock = modeABlock;
		}
		break;
	    case F_MAZEGAKI_START: //Ѵ
		if(mazeAble == MAZE_USE) {
		    if(inputMode == INPUT_NORMAL) {
			//minibuffer
			inputMode = INPUT_MAZEGAKI;
			clearMiniBuffer();
		    } else {
			mazeSub();
		    }
		}
		break;
	    //<si>
#ifndef ORIG
	    // ַ򤼽Ѵ
	    case F_KOUCHI1:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(1);}else{mazeSub();}
	        break;
	    case F_KOUCHI2:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(2);}else{mazeSub();}
	        break;
	    case F_KOUCHI3:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(3);}else{mazeSub();}
	        break;
	    case F_KOUCHI4:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(4);}else{mazeSub();}
	        break;
	    case F_KOUCHI5:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(5);}else{mazeSub();}
	        break;
	    case F_KOUCHI6:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(6);}else{mazeSub();}
	        break;
	    case F_KOUCHI7:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(7);}else{mazeSub();}
	        break;
	    case F_KOUCHI8:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(8);}else{mazeSub();}
	        break;
	    case F_KOUCHI9:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(9);}else{mazeSub();}
	        break;
	    // إɽ
	    case F_HELP: helpMode = 1; break;
	    case F_HELP_NEXT: helpBufferNext(); break;
	    // ΤޤޤΥ
	    case F_VERBATIM:
	    	if(inputMode == INPUT_NORMAL){
		    currentBlock = rootBlock;
		    outputKey(tCodeKey[wParam]);
		}
		//<si>
		// 򤼽ѴǡSPC ä顢Ѵμ¹
		else if(inputMode == INPUT_MAZEGAKI && wParam == 40){
		    mazeSub();
		}
		//</si>
#endif
	    //</si>
#ifdef BUSHU
	    case F_BUSHU:	// Ѵ
		if(bushuAble == BUSHU_USE) {
		    if(inputMode == INPUT_NORMAL) {
			//minibuffer
			inputMode = INPUT_BUSHU;
			clearMiniBuffer();
		    }
		    //XXX: ƵŪѴ򤼽ѴȤȤ߹礻̤
		}
		break;
# ifndef ORIG
	    case F_KOUCHIBUSHU:	// ַѴ
		if(bushuAble == BUSHU_USE) {
		    if(inputMode == INPUT_NORMAL) {
			bushuKouchi();
		    }
		}
		break;
# endif
#endif
	    default:
		break;
	    }
	    currentBlock = rootBlock;
	    break;
	default:
	    break;
	}
	break;
    }

    //λξ֤ǡEscBsʤɤݤ뤫뤫
//    setSpecialHotKey();
    //<si>
#ifndef ORIG
    // ʤǡȥȤƤΤʬʤɡ
    // ȼСESC Ȥ BS ȤޤƤ줽
    // ȼäƤߤ
    // ġĤäѤꡢ᤿ä
    //setSpecialHotKey();
#endif
    //</si>

    //ȥʸ򹹿
    setTitleText();

    //windowľ
    RedrawWindow(hwnd, NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
    return 0;
}

//<si>
#ifndef ORIG
// ַ򤼽Ѵ
void TableWindow::mazeKouchi(int yomiCount){
    char yomi[RINGBUFFERSIZE];
    int ringCount = countChar(ringBuffer);
    if(ringCount < yomiCount){
	// ꤵ줿ʸˡ­ʤ
	// ⤷ʤ
	currentBlock = rootBlock;
	inputMode = INPUT_NORMAL;
    }else{
	strncpy(yomi, ringBuffer + (ringCount - yomiCount) * 2, yomiCount * 2);
	// ʤ󤫡ȴ
	yomi[yomiCount * 2] = '\0';
	outputKey(VK_BACK, yomiCount); // BS äơɤߤ (!)
	// Ȥϡ˽Ф
	inputMode = INPUT_NORMAL;
	clearMiniBuffer();
	outputStringToMiniBuffer(yomi);
	mazeSub();
	clearRingBuffer();
    }
}
#endif
//</si>

//Ѵ¹
void TableWindow::mazeSub() {
    if(miniBufferSize == 0) {
	//ξϲ⤻
	currentBlock = rootBlock;
	inputMode = INPUT_NORMAL;
    } else if(mgTable->setCand((char *)miniBuffer)) {
	//Τ
	//οʬ
	currentCand = mgTable->cand;
	offset = 0;
	int number = currentCand->size();
	if(number == 1) {
	    //Ĥξ硢¨
	    outputString((*mgTable->cand)[0]);
	    //<si>
#ifndef ORIG
	    // إоʸϿ
	    outputToHelpBuffer((*mgTable->cand)[0]);
#endif
	    //</si>
	    clearMiniBuffer();
	    //⡼ɤ̤᤹
	    currentBlock = rootBlock;
	    inputMode = INPUT_NORMAL;
	} else if(number <= 10) {
	    //10İʲξ
	    inputMode = INPUT_CAND_F;
	} else {
	    //¿ξ
	    inputMode = INPUT_CAND_M;
	}
    }
}

#ifdef BUSHU
# ifndef ORIG
// ַѴ
void TableWindow::bushuKouchi(){
    if(countChar(ringBuffer) >= 2){
	moji_t moji[2];
	char *s[2];
	int i = 0;
	char *p;
	for(p = ringBuffer; *p != '\0'; i ^= 1) {	// get last two moji
	    s[i] = p;
	    moji[i] = get_moji(&p);
	}
	int ch = tcode_lookup_outset(moji[i], moji[i^1]);
	if(ch != 0){
	    char tmp[] = { (ch>>8) & 0xff, ch & 0xff, '\0' };
	    outputKey(VK_BACK, 2); // BS äơʸ (!)
	    *s[i] = '\0';
	    Sleep(0);	// VK_BACKƤۤ (USEWMCHAR=ONн)
	    outputString(tmp);
	    outputToHelpBuffer(tmp);
	    outputToRingBuffer(tmp);
	}
    }
    currentBlock = rootBlock;
    inputMode = INPUT_NORMAL;
}
# endif	/* ORIG */
#endif	/* BUSHU */

//<si>
// إ״ط
#ifndef ORIG
// إоʸǼХåե򥯥ꥢ
void TableWindow::clearHelpBuffer(){
    helpBuffer[0] = '\0';
    helpBufferPtr = helpBuffer;
}

// إоʸХåեǡʸ 1 ʸʤ
void TableWindow::helpBufferNext(){
    if(!*helpBuffer){return;}
    if(IS_SJIS1(*helpBufferPtr) && 2 <= strlen(helpBufferPtr)){
	// 2 Хʸʤ顢2 Хȿʤ
	helpBufferPtr += 2;
    }else{
	helpBufferPtr += 1;
    }
    if(*helpBufferPtr == '\0'){
	// üޤ褿顢ᤷ
	helpBufferPtr = helpBuffer;
    }
    helpMode = 1;
}

// إоʸȤϿ
void TableWindow::outputToHelpBuffer(char *str){
    clearHelpBuffer();
    strncpy(helpBuffer, str, HELP_BUFFER_SIZE - 2);
    helpBuffer[HELP_BUFFER_SIZE - 1] = helpBuffer[HELP_BUFFER_SIZE - 2] = '\0';
    helpMode = 1;
}

// إѤΥơ֥򥯥ꥢ
void TableWindow::clearStrokeTable(){
    for(int b1 = 0; b1 < 128; b1++){
	for(int b2 = 0; b2 < 256; b2++){
	    strokeTable[b1][b2] = 0;
	}
    }
}

// إѤΥơ֥θ
void TableWindow::deleteStrokeTable(){
    char *stroke;
    for(int b1 = 0; b1 < 128; b1++){
	for(int b2 = 0; b2 < 256; b2++){
	    if((stroke = strokeTable[b1][b2]) != 0){
		delete stroke;
	    }
	}
    }
}

// إѤΥơ֥
void TableWindow::makeStrokeTable(){
    makeStrokeTableSub(modeABlock, "");
}

// إѤΥơ֥ ()
void TableWindow::makeStrokeTableSub(Block *currentBlock,
                                     char *strokeHead){
    if(currentBlock == 0){
	// ֥󥯤ξ
	// ⤷ʤ
	return;
    }
    switch(currentBlock->kind()){
    char *str;
    case STRING_BLOCK:
	// ʸ֥åξ
	// Shift-JIS  1 ʸξʤ顢Ͽ
	str = ((StringBlock *)currentBlock)->str;
	if(!(IS_SJIS1(*str) && strlen(str) == 2)){return;}
	//strokeTable[*str & 0x7f][*(str + 1)] = strdup(strokeHead);
	STROKE_TABLE(str) = strdup(strokeHead);
	return;
    case CONTROL_BLOCK:
	int tCodeKeyNum;
	// ȥ֥åξ
	// ƵƤӽФ
	for(tCodeKeyNum = 0; tCodeKeyNum < KEY_NUMBER; tCodeKeyNum++){
	    Block *nextBlock =
	      (((ControlBlock *)currentBlock)->block)[tCodeKeyNum];
	    char *stroke = new char(strlen(strokeHead) + 2);
	    strcpy(stroke, strokeHead);
	    stroke[strlen(strokeHead)] = tCodeKeyNum | 0x80;
	    stroke[strlen(strokeHead) + 1] = '\0';
	    makeStrokeTableSub(nextBlock, stroke);
	    delete stroke;
	}
	return;
    case SPECIAL_BLOCK:
	// üξ
	// ⤷ʤ
	return;
    default:
	break;
    }
}

void TableWindow::drawHelp(HDC hdc){
    char mark[KEY_NUMBER][3];
    // ۸ס֡פȤ֡פȤ֡פȤ
    // 3 == 2 bytes + 1 (for '\0')

    if(!IS_SJIS1(*helpBufferPtr)){
	// Shift-JIS ʤä顢⤷ʤ
	// (strokeTable  Shift-JIS ʤ褦ˤʤäƤ뤷)
	helpMode = 0;
	return;
    }
    //char *stroke = strokeTable[MSBOFF(*helpBufferPtr)][*(helpBufferPtr + 1)];
    char *stroke = STROKE_TABLE(helpBufferPtr);

    //ʸο
    SetTextColor(hdc, BLACK);
    SetBkColor(hdc, LGRAY);

    // minibuffer оݤȤʤʸɽ
    SelectObject(hdc, hLFont);
    int px = BLOCK_SIZE * 5;
    int py = BLOCK_SIZE * 1.5;
    TextOut(hdc, px + 1, py + 1, helpBufferPtr, 2);

    if(!stroke || !*stroke){return;}
    // ȥʤСȥɽʤ

    // ۸פ
    for(int i = 0; i < KEY_NUMBER; i++){
        strcpy(mark[i], "");
    }

    // ۸׾ɽ뵭
    if(strlen(stroke) == 4 &&
       MSBOFF(stroke[0]) == 26 && MSBOFF(stroke[1]) == 23){
        //  T-Code αɽ
        strcpy(mark[MSBOFF(stroke[3])], ""); // shifted second
        strcpy(mark[MSBOFF(stroke[2])], ""); // shifted first
    }else if(strlen(stroke) == 4 &&
             MSBOFF(stroke[0]) == 23 && MSBOFF(stroke[1]) == 26){
        //  T-Code κɽ
        strcpy(mark[MSBOFF(stroke[3])], ""); // shifted second
        strcpy(mark[MSBOFF(stroke[2])], ""); // shifted first
    }else{
	int needOptionalSameStroke = 0;
        for(int th = 0; stroke[th] != '\0'; th++){
            int k = MSBOFF(stroke[th]);
            // Ǿ̥ӥåȤƤ (strokeTable ͤʤΤ)

            switch(th){
            case 0: // first
                strcpy(mark[k], "");
                break;
            case 1: // second
                if(strcmp(mark[k], "") != 0){
                    strcpy(mark[k], "");
                    needOptionalSameStroke = 1;
                }else{
                    strcpy(mark[k], "");
                }
                break;
            case 2: // third
                if(strcmp(mark[k], "") != 0){
		    if(needOptionalSameStroke){
                        strcpy(mark[k], "");
                    }else{
                        strcpy(mark[k], "");
                        needOptionalSameStroke = 1;
                    }
                }else{
                    strcpy(mark[k], "");
                }
                break;
            default: // forth
                if(strcmp(mark[k], "") != 0){
		    if(needOptionalSameStroke){
                        strcpy(mark[k], "");
                    }else{
                        strcpy(mark[k], "");
                        needOptionalSameStroke = 1;
                    }
                }else{
                    strcpy(mark[k], "");
                }
                break;
            }
        }
    }

    //եȤ
    SelectObject(hdc, hFont);

    //ʸο
    SetTextColor(hdc, BLACK);
    SetBkColor(hdc, LGRAY);

    int count = 0;
    for(int y = 0; y < 5; y++){
        for(int x = 0; x < 10; x++){
            int px = BLOCK_SIZE * x - 1;
            int py = BLOCK_SIZE * y;
            if(y == 4){
                px += BLOCK_SIZE / 2;
            }else if(5 <= x){
                px += BLOCK_SIZE;
            }

            if(strcmp(mark[count], "") != 0){
                TextOut(hdc, px + 3, py + 3, mark[count], 2);
            }else{
                if((x % 10 <= 3 || 6 <= x % 10) && (1 <= y && y <= 3)){
		    // ۡݥȤξ岼λʤϡ֡פɽ
                    TextOut(hdc, px + 3, py + 3, "", 2);
                }
            }

            count++;
            if(count == KEY_NUMBER){
                break;
            }
        }
    }
}
#endif
//</si>

//ʸȤ
void TableWindow::drawFrame(HDC hdc) {
    //ڥ
    HPEN blackPen = CreatePen(PS_SOLID, 1, BLACK);
    HPEN grayPen = CreatePen(PS_SOLID, 1, GRAY);
    HPEN whitePen = CreatePen(PS_SOLID, 1, WHITE);

    //Ȥɽ
    for(int y = 0; y < 5; y++) {
	for(int x = 0; x < 10; x++) {
	    int px = BLOCK_SIZE * x;
	    int py = BLOCK_SIZE * y;
	    if(y == 4) {
		px += BLOCK_SIZE / 2 - 1;
	    } else if(x >= 5) {
		px += BLOCK_SIZE;
	    }

	    //ʬɽ
	    HGDIOBJ tmp = SelectObject(hdc, whitePen);
	    MoveToEx(hdc, px, py, NULL);
	    LineTo(hdc, px + BLOCK_SIZE - 1, py);
	    MoveToEx(hdc, px, py, NULL);
	    LineTo(hdc, px, py + BLOCK_SIZE - 1);

	    //ʬɽ
	    SelectObject(hdc, blackPen);
	    MoveToEx(hdc, px + BLOCK_SIZE - 1, py, NULL);
	    LineTo(hdc, px + BLOCK_SIZE - 1, py + BLOCK_SIZE);
	    MoveToEx(hdc, px, py + BLOCK_SIZE - 1, NULL);
	    LineTo(hdc, px + BLOCK_SIZE, py + BLOCK_SIZE - 1);

	    //ʬɽ
	    SelectObject(hdc, grayPen);
	    MoveToEx(hdc, px + BLOCK_SIZE - 2, py, NULL);
	    LineTo(hdc, px + BLOCK_SIZE - 2, py + BLOCK_SIZE - 1);
	    MoveToEx(hdc, px + 1, py + BLOCK_SIZE - 2, NULL);
	    LineTo(hdc, px + BLOCK_SIZE - 1, py + BLOCK_SIZE - 2);
	    SelectObject(hdc, tmp);
	}
    }

    //ڥ
    DeleteObject(blackPen);
    DeleteObject(grayPen);
    DeleteObject(whitePen);
}

//ʸ(Ľ10)
void TableWindow::drawLongFrame(HDC hdc) {
    //ڥ
    HPEN blackPen = CreatePen(PS_SOLID, 1, BLACK);
    HPEN grayPen = CreatePen(PS_SOLID, 1, GRAY);
    HPEN whitePen = CreatePen(PS_SOLID, 1, WHITE);

    //Ȥɽ
    for(int x = 0; x < 10; x++) {
	int px = BLOCK_SIZE * x;
	if(x >= 5) {
	    px += BLOCK_SIZE;
	}

	//ʬɽ
        HGDIOBJ tmp = SelectObject(hdc, whitePen);
	MoveToEx(hdc, px, 0, NULL);
	LineTo(hdc, px + BLOCK_SIZE - 1, 0);
	MoveToEx(hdc, px, 0, NULL);
	LineTo(hdc, px, BLOCK_SIZE * 5 - 1);

	//ʬɽ
	SelectObject(hdc, blackPen);
	MoveToEx(hdc, px + BLOCK_SIZE - 1, 0, NULL);
	LineTo(hdc, px + BLOCK_SIZE - 1, BLOCK_SIZE * 5);
	MoveToEx(hdc, px, BLOCK_SIZE * 5 - 1, NULL);
	LineTo(hdc, px + BLOCK_SIZE, BLOCK_SIZE * 5 - 1);

	//ʬɽ
	SelectObject(hdc, grayPen);
	MoveToEx(hdc, px + BLOCK_SIZE - 2, 0, NULL);
	LineTo(hdc, px + BLOCK_SIZE - 2, BLOCK_SIZE * 5 - 1);
	MoveToEx(hdc, px + 1, BLOCK_SIZE * 5 - 2, NULL);
	LineTo(hdc, px + BLOCK_SIZE - 1, BLOCK_SIZE * 5 - 2);

	SelectObject(hdc, tmp);
    }

    //ڥ
    DeleteObject(blackPen);
    DeleteObject(grayPen);
    DeleteObject(whitePen);
}

//顼λ
void TableWindow::error(char *mes) {
    MessageBoxEx(hwnd, mes, "ľWin:顼",
		 MB_OK | MB_ICONERROR, LANG_JAPANESE);
    PostQuitMessage(0);
}
