//class TableWindow
//C̃EBhE֘Ȁ

#ifndef TABLE_WINDOW_H
#define TABLE_WINDOW_H

#include<iostream.h>
#include<fstream.h>
#include<windows.h>
#include<imm.h>
#include<stdio.h>
#include<stdlib.h>
#include<vector>
//#include"common.h"
#include"block.h"
#include"mg_table.h"
#include"value.h"
#include"parser.h"
#ifdef BUSHU
# include"comp.h"
#endif

//bZ[W
#define KANCHOKU_ICONCLK 0x1001

//OnAOff̐؂ւL[
#define ACTIVE_KEY (KEY_NUMBER + 1)
#define ESC_KEY    (KEY_NUMBER + 2)
#define BS_KEY     (KEY_NUMBER + 3)
#define CH_KEY     (KEY_NUMBER + 4)
//<si>
#ifndef ORIG
#define RET_KEY    (KEY_NUMBER + 5)
#define CM_KEY     (KEY_NUMBER + 6)
#define CJ_KEY     (KEY_NUMBER + 7)
#define TAB_KEY    (KEY_NUMBER + 8)
#endif
//</si>

//̑傫
#define CHAR_SIZE (12)

//傫̑傫
#define LARGE_CHAR_SIZE (16)

//}X̑傫
#define BLOCK_SIZE (18)

//F
#define BLACK (RGB(0,0,0))
#define GRAY (RGB(0x80,0x80,0x80))
#define LGRAY (RGB(0xc0,0xc0,0xc0))
#define WHITE (RGB(0xff, 0xff, 0xff))

//e[ũ[h
#define MODE_A 0
#define MODE_B 1

//̓[h
#define INPUT_NORMAL   0
#define INPUT_MAZEGAKI 1
#define INPUT_CAND_F   2
#define INPUT_CAND_M   3
#ifdef BUSHU
#define INPUT_BUSHU    4
#endif

//ϊ\ǂ
#define MAZE_NOT_USE 0
#define MAZE_USE     1

#ifdef BUSHU
//񍇐ϊ\ǂ
#define BUSHU_NOT_USE 0
#define BUSHU_USE     1
#endif

//ϊ̃TCY
#define MINI_BUFFER_SIZE 256

class TableWindow {
private:
    //ϊgǂ
    int mazeAble;

#ifdef BUSHU
    //񍇐ϊgǂ
    int bushuAble;
#endif

    //Bǂ
    int hideMode;

    //o郁bZ[W(WM_CHARAWM_IME_CHAR)
    int messageKind;

    //<si>
#ifndef ORIG
    // BS ̋
    int forceBSMode;
    // ϊœ͂̃wv\邩
    int showHelpMode;
#endif
    //</si>

    //e[u
    MgTable *mgTable;

    //zL[R[h̕\
    int *tCodeKey;

    //ϊ̕
    char *miniBuffer;
    int miniBufferSize;   //̒
    int miniBufferCount;  //

    //oL^ĂO
    
    //<si>
#ifndef ORIG
    #define RINGBUFFERSIZE (2 * 10 + 1) // Sp 10 
    char ringBuffer[RINGBUFFERSIZE];

    // O T-Code L[ (0 .. 39)
    int lastTCodeKeyNum;
#endif
    //</si>

    //activeǂ
    int isActive;

    //e[ũ[h(MODE_AMODE_B)
    int tableMode;

    //̓[h
    int inputMode;

    //modeAmodeBꂼ̃[gubN
    ControlBlock *modeABlock;
    ControlBlock *modeBBlock;

    //݂̃[gubN
    ControlBlock *rootBlock;

    //\ĂubN
    ControlBlock *currentBlock;

    //\Ă╶vectoroffset
    std::vector<char *> *currentCand;
    //<si>
#ifdef ORIG
    int offset;
#else
    unsigned int offset;
#endif
    //</si>

    //<si>
    // wv\
#ifndef ORIG
#define HELP_BUFFER_SIZE 128
    char helpBuffer[HELP_BUFFER_SIZE];
    // wvΏۂ̕ (ϊ) i[
    char *helpBufferPtr;
    int helpMode;
    char *strokeTable[128][256];
    // Shift-JIS ́̕A
    // {gbvrbg𗎂Ƃ 1 oCg}  {C̑ 2 oCg} 
    // e[u
    // (0x80 | (T-Code L[ԍ)) ̃oCgi[ (L[ԍ 0 
    // I[ƂȂȂ悤)
#define STROKE_TABLE(str) (strokeTable[*(str) & 0x7f][*((str) + 1)])
#endif
    //</si>

    //CX^Xnh
    HINSTANCE instance;

    //tHg
    HFONT hFont;
    HFONT hLFont;

    //rbg}bv
    HBITMAP bmOff;
    HBITMAP bmOn1;
    HBITMAP bmOn2;

    //bZ[Ẅi[
    HWND hwnd;
    WPARAM wParam;
    WPARAM lParam;

public:
    //window procedure
    int wndProc(HWND, UINT, WPARAM, LPARAM);

    //RXgN^
    TableWindow(HINSTANCE i);

    //fXgN^
    ~TableWindow();

private:
    //N(HotKeẙt)
    void activate();

    //ҋ@(HotKeỷ)
    void inactivate();

    //HotKeẙmۂƉ
    void setSpecialHotKey();

    //^Cgo[̕ݒ
    void setTitleText();

    //̏o
    void outputString(char *);
    void outputStringToMiniBuffer(char *);

    //<si>
#ifndef ORIG
    // L[̏o
    void outputKey(int, int);
    void outputKey(int);

    // u^ϊ֘A
    void outputToRingBuffer(char *);
    void clearRingBuffer();
    void backspaceRingBuffer();
    void mazeKouchi(int);
#endif
    //</si>

    //𐔂
    int countChar(char *);

    //mini buffer̃NA
    void clearMiniBuffer();

    //bZ[Wnh
    int handleCreate();       //WM_CREATE
    int handlePaint();        //WM_PAINT
    int handleDestroy();      //WM_DESTROY
    int handleLButtonDown();  //WM_LBUTTONDOWN
    int handleHotKey();       //WM_HOTKEY

    //
    void mazeSub();
#ifdef BUSHU
# ifndef ORIG
    //u^񍇐ϊ
    void bushuKouchi();
# endif
#endif

    //<si>
    // wv\
#ifndef ORIG
    void clearHelpBuffer();
    void helpBufferNext();
    void outputToHelpBuffer(char *);
    void clearStrokeTable();
    void deleteStrokeTable();
    void makeStrokeTable();
    void makeStrokeTableSub(Block *, char *);
    void drawHelp(HDC);
#endif
    //</si>

    //g`
    void drawFrame(HDC hdc);
    void drawLongFrame(HDC hdc);

    //G[I
    void error(char *);
};

#endif
